﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DynamicNavigationApplication
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        // After the Frame navigates, ensure the HyperlinkButton representing the current page is selected
        private void ContentFrame_Navigated(object sender, NavigationEventArgs e)
        {
            foreach (UIElement child in LinksStackPanel.Children)
            {
                HyperlinkButton hb = child as HyperlinkButton;
                if (hb != null && hb.NavigateUri != null)
                {
                    if (hb.NavigateUri.ToString().Equals(e.Uri.ToString()))
                    {
                        VisualStateManager.GoToState(hb, "ActiveLink", true);
                    }
                    else
                    {
                        VisualStateManager.GoToState(hb, "InactiveLink", true);
                    }
                }
            }
        }

        // If an error occurs during navigation, show an error window
        private void ContentFrame_NavigationFailed(object sender, NavigationFailedEventArgs e)
        {
            e.Handled = true;
            ChildWindow errorWin = new ErrorWindow(e.Uri);
            errorWin.Show();
        }

        private int toLoad = 2;
        private object loadLock = new object();
        private void LoadLibraries_Click(object sender, RoutedEventArgs e)
        {
            if (toLoad > 0)
            {
                WebClient wc = new WebClient();
                wc.OpenReadCompleted += new OpenReadCompletedEventHandler(wc_OpenReadCompleted);
                WebClient wc2 = new WebClient();
                wc2.OpenReadCompleted += new OpenReadCompletedEventHandler(wc_OpenReadCompleted);
                activity.IsActive = true;
                wc.OpenReadAsync(new Uri(Application.Current.Host.Source, "./DynamicallyLoadedLibrary.dll"), "C#");
                wc2.OpenReadAsync(new Uri(Application.Current.Host.Source, "./DynamicallyLoadedLibraryVB.dll"), "VB");
            }
        }

        void wc_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            lock (loadLock)
            {
                new AssemblyPart().Load(e.Result);
                toLoad--;
                if (toLoad == 0)
                    activity.IsActive = false;
                //MessageBox.Show("Finished Loading " + e.UserState + "!");
                switch (e.UserState.ToString())
                {
                    case "C#":
                        csharp.IsEnabled = true;
                        break;
                    case "VB":
                        vb.IsEnabled = true;
                        break;
                }
            }
        }
    }
}